<?php
include("funkcie.php");

function dropni_tempy() {
    sprav_dotaz("DROP TEMPORARY TABLE tmp1");
    sprav_dotaz("DROP TEMPORARY TABLE tmp2");    
}

function daj_sql($tmp1_create, $tmp2_create, $tmp2_insert, $vysledny_sql_bez_limitu) {
    sprav_dotaz($tmp1_create);
    sprav_dotaz($tmp2_create);
    sprav_dotaz($tmp2_insert);
    return $vysledny_sql_bez_limitu; 
}

$filtrovanie = "LOWER(original_name) LIKE LOWER('%" . $_SESSION['reb_original_name'] . "%') AND
                LOWER(cs_name) LIKE LOWER('%" . $_SESSION['reb_cs_name'] . "%') AND
                zaner LIKE '%" . $_SESSION['reb_zaner'] . "%' AND
                natacanie LIKE '%" . $_SESSION['reb_natacanie'] . "%' AND
                LOWER(reziser) LIKE LOWER('%" . $_SESSION['reb_reziser'] . "%') AND
                LOWER(herci) LIKE LOWER('%" . $_SESSION['reb_herec'] . "%') AND
                vydanie >= " . $_SESSION['reb_vydanie_od'] . " AND
                vydanie <= " . $_SESSION['reb_vydanie_do'] . " AND
                hodnotenie >= " . $_SESSION['reb_hodnotenie_od'] . " AND
                hodnotenie <= " . $_SESSION['reb_hodnotenie_do'] . " AND
                vlastne_hodnotenie >= " . $_SESSION['reb_vlastne_hodnotenie_od'] . " AND
                vlastne_hodnotenie <= " . $_SESSION['reb_vlastne_hodnotenie_do'];
$tmp1_create = "CREATE TEMPORARY TABLE tmp1 (
                SELECT fp.id, fp.original_name, fp.cs_name, fp.vydanie, fp.zaner, fp.natacanie, fp.reziser, fp.herci, fp.hodnotenie, AVG(fpp.vlastne_hodnotenie) AS vlastne_hodnotenie, COUNT(fp.id) AS pocet_pouzivatelov
                FROM film_public fp, film_private fpp
                WHERE fp.id = fpp.id_film
                GROUP BY fp.id)"; 
$tmp2_create = "CREATE TEMPORARY TABLE tmp2 (
                id INT NOT NULL,
                original_name VARCHAR(50) NOT NULL,
                cs_name VARCHAR(50) NOT NULL,
                vydanie INT NOT NULL,
                hodnotenie TINYINT NOT NULL,
                zaner VARCHAR(1500) NOT NULL,
                natacanie VARCHAR(1500) NOT NULL,
                reziser VARCHAR(1500) NOT NULL,
                herci VARCHAR(1500) NOT NULL,
                vlastne_hodnotenie TINYINT NOT NULL DEFAULT 0,
                pocet_pouzivatelov INT NOT NULL DEFAULT 0)";
$tmp2_insert = "INSERT INTO tmp2 (id, original_name, cs_name, vydanie, hodnotenie, zaner, natacanie, reziser, herci)
                SELECT id, original_name, cs_name, vydanie, hodnotenie, zaner, natacanie, reziser, herci FROM film_public 
                WHERE (id, original_name, cs_name, vydanie, hodnotenie, zaner, natacanie, reziser, herci) 
                NOT IN (SELECT film_public.id, original_name, cs_name, vydanie, hodnotenie, zaner, natacanie, reziser, herci 
                FROM film_public, film_private WHERE film_public.id = film_private.id_film)";
$cislo_alebo_nazov_na_zoradenie = ($_SESSION['reb_order_by'] == 'original_name' || $_SESSION['reb_order_by'] == 'cs_name') ? 'LOWER(' . $_SESSION['reb_order_by'] . ')' : $_SESSION['reb_order_by'];       
$vysledny_sql_bez_limitu = "SELECT * FROM (
           SELECT id, original_name, cs_name, vydanie, hodnotenie, vlastne_hodnotenie, pocet_pouzivatelov, zaner, natacanie, reziser, herci FROM tmp1 
           UNION
           SELECT id, original_name, cs_name, vydanie, hodnotenie, vlastne_hodnotenie, pocet_pouzivatelov, zaner, natacanie, reziser, herci FROM tmp2 
           ) AS T WHERE " . $filtrovanie . "
           ORDER BY " . $cislo_alebo_nazov_na_zoradenie . " " . $_SESSION['reb_order_how'];

if (isset($_SESSION['id'])) {
    ?><h2>Najlepšie filmy podľa oficiálneho hodnotenia</h2><table><?php
    $zaznamov = 0;
    if ($link = spoj_s_db()) {        
        $sql = daj_sql($tmp1_create, $tmp2_create, $tmp2_insert, $vysledny_sql_bez_limitu);
        $result1 = mysql_query($sql, $link); // vykonaj dotaz
        if ($result1) {
            $zaznamov = mysql_num_rows($result1);
            mysql_free_result($result1);
        }
        if ($zaznamov == 0 && $_SESSION['reb_strana'] > 0)
            $_SESSION['reb_strana'] = 0;
        dropni_tempy();
        $sql = daj_sql($tmp1_create, $tmp2_create, $tmp2_insert, $vysledny_sql_bez_limitu . " LIMIT " . ($_SESSION['reb_strana'] * $_SESSION['reb_pocet_strana']) . "," . $_SESSION['reb_pocet_strana']);        
        $result = mysql_query($sql, $link); // vykonaj dotaz
        if ($result) {
            // dotaz sa podarilo vykonať
            if (mysql_num_rows($result) == 0) {                
                ?><p>Momentálne nie je v databáze žiadny film alebo neexistuje film podľa filtrovania.</p><?php
                $ano = false;
            } else {
                $ano = true; 
                ?><table style="font-size: 80%"><tr>
                            <th></th><?php
                            echo vypis_th_zoradovanie('reb', 'original_name', 'Zoraď podľa originálneho názvu', 'Orig. názov');
                            echo vypis_th_zoradovanie('reb', 'cs_name', 'Zoraď podľa českého / slovenského názvu', 'CZ / SK názov');
                            echo vypis_th_zoradovanie('reb', 'vydanie', 'Zoraď podľa roku vydania', 'Rok vyd.');
                            echo vypis_th_zoradovanie('reb', 'hodnotenie', 'Zoraď podľa oficiálneho hodnotenia', 'OH');
                            echo vypis_th_zoradovanie('reb', 'vlastne_hodnotenie', 'Zoraď podľa hodnotenia používateľov', 'HP');
                            ?><th>Žáner</th><?php
                            ?><th>Režiséri</th><?php
                            ?><th>Herci</th><?php
                            ?><th title="Počet používateľov, ktorí majú tento film vo svojej databáze">PP</th><?php
                        ?></tr><?php
                $i = ($_SESSION['reb_strana'] * $_SESSION['reb_pocet_strana']);
                while ($row = mysql_fetch_assoc($result)) {
                    $i++;
                    echo '<tr class="v1 obsah_tab" title="Prejdi na film" onclick="javascript:window.location.href=\'film_info.php?id=' . $row['id'] . '\'">
                        <td class="cislo">' . $i . '.</td>
                        <td style="font-weight: bold">' . $row['original_name'] . '</td>
                        <td>' . $row['cs_name'] . '</td>
                        <td>' . $row['vydanie'] . '</td>
                        <td>' . $row['hodnotenie'] . '%</td>
                        <td>' . round($row['vlastne_hodnotenie']) . '%</td>
                        <td>' . vypis_viac_veci_z_jedneho($row['zaner']) . '</td>
                        <td>' . vypis_viac_veci_z_jedneho($row['reziser']) . '</td>
                        <td>' . vypis_viac_veci_z_jedneho($row['herci']) . '</td>
                        <td>' . $row['pocet_pouzivatelov'] . '</td></tr>';
                }
                ?></table><?php
                mysql_free_result($result);
            }
            dropni_tempy();
        }         
        mysql_close($link);
    } else {
        // NEpodarilo sa spojiť s databázovým serverom!
    }
    ?></table><?php
    if ($ano) {
        vypis_pocet_zaznamov_na_stranu('select_zaznamov_na_stranu', 'reb');
        vypis_strany('select_strana', $zaznamov, 'reb');       
    }
} else echo NENI_PRISTUP;
?>